/* This is "horizon.c", written to accompany Introduction to
   Scientific Programming by Joseph L. Zachary .*/

/* This program finds the distance to the horizon from the top of a
   hill using the method described in Chapter 5 of the text. */


#include <stdio.h>
#include <math.h>



/* We obtain the radius of the earth and the height of the hill in
   feet, and then compute and display the distance to the horizon
   using Formula 5.6 from the text. */

void main (void)
{
  double radius,     /* Radius of the earth in feet. */
         height,     /* Height of the hill in feet. */
         distance;   /* Calculated distance to the horizon in feet. */

  printf("Enter radius of earth (ft): ");
  scanf("%lf", &radius);

  printf("Enter height of hill (ft): ");
  scanf("%lf", &height);
  
  distance = sqrt(2*radius*height + height*height);

  printf("Distance to horizon is %g ft\n", distance);
}
