/* This is "limits.c", written to accompany Introduction to
   Scientific Programming by Joseph L. Zachary .*/

/* This program determines and displays the valid ranges of the various
   types of floating-point numbers and integers provided by your version
   of C. */
   

#include <stdio.h>
#include <limits.h>
#include <float.h>



/* This uses a few escoteric printf conversion specifications to ensure
   that floating-point numbers of the proper length are displayed in
   each case.  You don't need to understand how this program works to
   benefit from the information it displays. */

void main (void) {

  printf("Minimum short = %d\n", SHRT_MIN);
  printf("Maximum short = % d\n\n", SHRT_MAX);

  printf("Minimum int = %d\n", INT_MIN);
  printf("Maximum int = % d\n\n", INT_MAX);

  printf("Minimum long = %ld\n", LONG_MIN);
  printf("Maximum long = % ld\n\n", LONG_MAX);

  printf("Minimum positive float = %#.*g\n", FLT_DIG, FLT_MIN);
  printf("Maximum positive float = %#.*g\n\n", FLT_DIG, FLT_MAX);

  printf("Minimum positive double = %#.*g\n", DBL_DIG, DBL_MIN);
  printf("Maximum positive double = %#.*g\n\n", DBL_DIG, DBL_MAX);

  printf("Minimum positive long double =\n\t %#.*Lg\n", LDBL_DIG, LDBL_MIN);
  printf("Maximum positive long double =\n\t %#.*Lg\n", LDBL_DIG, LDBL_MAX);
  
}
