{VERSION 1 0 "X11/Motif" "1.0"}{GLOBALS 1 1}{FONT 0 "-adobe-helve
tica-bold-r-normal--*-140-*" "helvetica" "Helvetica-Bold" 8 14 0 
"Helvetica-Bold" 12}{FONT 1 "-adobe-times-medium-r-normal--*-140-
*" "times" "Times-Roman" 4 14 64 "Times-Roman" 12}{FONT 2 "-adobe
-courier-medium-r-normal--*-140-*" "courier" "Courier" 4 14 192 "
Courier" 12}{SCP_R 1 0 10{COM_R 2 0{TEXT 1 129 "This worksheet im
plements the \"newton\" package used in Chapter 14 of Introductio
n to Scientific Programming by Joseph L. Zachary."}}{SEP_R 3 0}
{COM_R 4 0{TEXT 1 26 "\015Create an empty package.\015"}}{INP_R 5
 0 "> "{TEXT 0 18 "newton := table();"}}{SEP_R 6 0}{COM_R 7 0
{TEXT 1 237 "Produces an animation showing how Newton's method co
nverges to a solution of the function \"h\", beginning from an in
itial guess \"g\".  There are \"nframes\"+1 frames created, and t
he portion of the x-axis to display is governed by \"domain\".\01
5"}}{INP_R 8 0 "> "{TEXT 0 2160 "newton[animateNewton] := proc (h
, guess, nframes, domain)\012\012    local i,                    \+
             # Loop counter\012             x,                   \+
             # Symbolic constant\012             plts,           \+
                # List of plots that makes up animation\012      \+
       g,                               # Keeps track of guesses\
012             hprime,                     # First derivative of
 h\012             thePlot,                     # The plot of h\0
12             lowRange,               # Range of y-axis\012     \+
        highRange,\012             doNewton,              # Local
 procedures\012             plotTangent;\012\012   # Does one ite
ration of Newton's method by improving the\012   # guess \"g\" fo
r the root of \"h\", where  \"hprime\" is the first\012   # deriv
ative of \"h\".\012\012    doNewton := (h, hprime, g) -> g - h(g)
/hprime(g);\012\012\012   # Produces a plot that contains a line \+
that is tangent to \"h\" at\012   # point \"tangent\".  The exten
t of the x-axis is specified as\012   # \"domain\", and the exten
t of the y-axis is specified as \"range\". \012   # The first der
ivative of \"h\" is \"hprime\".\015\012   plotTangent := proc (h,
 hprime, tangent, domain, range)\012       local x;\012       plo
t(hprime(tangent)*x + h(tangent) - hprime(tangent)*tangent,\012  \+
             x=domain,\012               range,\012              \+
 labels=[``,``]);\012       end;\012\012\012    # Determine the m
inimum and maximum extent of the range of \"h\".\012\012    lowRa
nge := minimize(h(x), \{x\}, \{x=evalf(domain)\});\012    highRan
ge := maximize(h(x), \{x\}, \{x=evalf(domain)\});\012\012    # Cr
eate a plot corresponding to each repetition of Newton's method.\
012\012    g := guess;\012    hprime := D(h);\012    plts := x$0;
\012    thePlot := plot(h(x), x=evalf(domain), lowRange..highRang
e, labels=[``,``]);\012\012    for i from 1 to nframes do\012    \+
    plts := plts, plots[display](\{thePlot,\012                  \+
                                      plotTangent(h, hprime, g, e
valf(domain),\012                                                \+
                                   lowRange..highRange)\});\012  \+
      g := doNewton(h, hprime, g);\012    od;\012\012    # Displa
y the plots in sequence to form an animation.\012\012    plots[di
splay]([thePlot,plts], insequence=true);\012\012    end;"}}{COM_R
 9 0{TEXT 1 0 ""}}{SEP_R 10 0}{INP_R 11 0 "> "{TEXT 0 0 ""}}}{END
}
